# Build project from bundled dependencies
%global with_bundled 1
# Build with debug info rpm
%global with_debug 1

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%if ! 0%{?gobuild:1}
%define gobuild(o:) go build -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n')" -a -v -x %{?**};
%endif

%global provider        github
%global provider_tld    com
%global project         kubernetes-csi
%global repo            external-attacher
# https://github.com/kubernetes-incubator/external-storage
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}

%global import_path     %{provider_prefix}
%global version         0.2.0
%global commit          27299be5386870a2b0100b1ee720c9227f8e1f8e
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           csi-attacher
Version:        %{version}
Release:        4.git%{shortcommit}%{?dist}
Summary:        External attacher for CSI volumes
License:        ASL 2.0
URL:            https://%{provider_prefix}
# Temporarily use current master (v0.2.0 + 14 commits) to use storage.k8s.io/v1beta1 api instead of v1alpha1
#Source0:        https://%{provider_prefix}/archive/v%{version}/external-attacher-v%{version}.tar.gz
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz
Patch1:         csi-attacher-0.2.0-leader-election.patch

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 aarch64 %{arm} ppc64le s390x}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%description
%{summary}.

%prep
#%setup -q -n %{repo}-%{version}
%setup -q -n%{repo}-%{commit}
%patch1 -p1

%build
mkdir -p src/%{provider}.%{provider_tld}/%{project}
ln -s ../../../ src/%{import_path}
export GOPATH=$(pwd):$(pwd)/repo-infra/vendor:%{gopath}

%gobuild -o ./bin/csi-attacher %{import_path}/cmd/csi-attacher

%install
install -d -p %{buildroot}%{_bindir}
install -p -m 0755 bin/csi-attacher %{buildroot}%{_bindir}

%files
%{_bindir}/csi-attacher
%license LICENSE
%doc README.md

%changelog
* Tue May 15 2018 jsafrane <jsafrane@redhat.com> - 0.2.0-3
- Add leader election (rhbz#1578310)

* Wed Apr 04 2018 jsafrane <jsafrane@redhat.com> - 0.2.0-1
- First release
